VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "clsDownload"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Attribute VB_Ext_KEY = "SavedWithClassBuilder6" ,"Yes"
Attribute VB_Ext_KEY = "Top_Level" ,"Yes"
'Dieser Source stammt von http://www.activevb.de
'und kann frei verwendet werden. Fr eventuelle Schden
'wird nicht gehaftet.
'
'Um Fehler oder Fragen zu klren, nutzen Sie bitte unser Forum.
'Ansonsten viel Spa und Erfolg mit diesem Source !
'
' Autor: Jonathan Haas <Jonathan.Haas@epost.de>


Option Explicit
Option Compare Text

Private Declare Function InternetOpen Lib "wininet" Alias _
        "InternetOpenA" (ByVal sAgent As String, ByVal _
        lAccessType As Long, ByVal sProxyName As String, ByVal _
        sProxyBypass As String, ByVal lFlags As Long) As Long
        
Private Declare Function InternetCloseHandle Lib "wininet" _
        (ByVal hInet As Long) As Integer
        
Private Declare Function InternetReadFile Lib "wininet" _
        (ByVal hFile As Long, ByVal sBuffer As String, ByVal _
        lNumBytesToRead As Long, lNumberOfBytesRead As Long) _
        As Integer
        
Private Declare Function InternetOpenUrl Lib "wininet" Alias _
        "InternetOpenUrlA" (ByVal hInternetSession As Long, _
        ByVal lpszUrl As String, ByVal lpszHeaders As String, _
        ByVal dwHeadersLength As Long, ByVal dwFlags As Long, _
        ByVal dwContext As Long) As Long

Private Declare Function InternetConnect Lib "wininet.dll" Alias "InternetConnectA" _
        (ByVal hInternetSession As Long, ByVal sServerName As String, ByVal nServerPort As Integer, _
        ByVal sUsername As String, ByVal sPassword As String, ByVal lService As Long, _
        ByVal lFlags As Long, ByVal lContext As Long) As Long

Private Declare Function HttpOpenRequest Lib "wininet.dll" Alias "HttpOpenRequestA" _
        (ByVal hHttpSession As Long, ByVal sVerb As String, ByVal sObjectName As String, ByVal sVersion As String, _
        ByVal sReferer As String, ByVal something As Long, ByVal lFlags As Long, ByVal lContext As Long) As Long

Private Declare Function HttpSendRequest Lib "wininet.dll" Alias "HttpSendRequestA" (ByVal _
        hHttpRequest As Long, ByVal sHeaders As String, ByVal lHeadersLength As Long, sOptional As _
        Any, ByVal lOptionalLength As Long) As Integer

Private Declare Function HttpQueryInfo Lib "wininet.dll" Alias "HttpQueryInfoA" _
        (ByVal hHttpRequest As Long, ByVal lInfoLevel As Long, ByRef sBuffer As Any, _
        ByRef lBufferLength As Long, ByRef lIndex As Long) As Integer

Const MAX_PATH = 260
Const INTERNET_DEFAULT_HTTP_PORT = 80
Const INTERNET_SERVICE_HTTP = 3

Const INTERNET_OPEN_TYPE_PRECONFIG = 0
Const INTERNET_OPEN_TYPE_DIRECT = 1
Const INTERNET_OPEN_TYPE_PROXY = 3
Const INTERNET_FLAG_RELOAD = &H80000000

Const HTTP_QUERY_STATUS_CODE = 19
Const HTTP_QUERY_STATUS_TEXT = 20
Const HTTP_QUERY_RAW_HEADERS = 21
Const HTTP_QUERY_RAW_HEADERS_CRLF = 22

Public Event Progresschanged(Progress As Double, ByRef Cancel As Boolean)
Public Event Statechanged(State As Downloadstate)
Public Event Startdownloading(Size As Long)

Public Enum Downloadstate
    DWready = 0
    DWconnecting = 1
    DWdownloading = 2
End Enum

' Durch Modifikation der Standardeinstelunng fr 'bytes' kann der Download
' in manchen Situationen beschleunigt werden
Public Function Downloadfile(url As String, Optional bytes As Long = 1024, Optional Useragent As String = "Download") As String
  Static hOpen As Long, hFile As Long, hinternetconnect As Long, hHttpOpenRequest As Long
  Dim OnExit As Boolean
  Dim Result As Long, Max As Long, tmp As String, Buffer As String, iretval As Long
  If url Like "http://*" Then url = Mid$(url, 8)
    Screen.MousePointer = vbHourglass
    'Falls noch Verbindungen bestehen, Beenden
        If hFile <> 0 Then Call InternetCloseHandle(hFile)
        If hOpen <> 0 Then Call InternetCloseHandle(hOpen)
        If hHttpOpenRequest <> 0 Then Call InternetCloseHandle(hHttpOpenRequest)
        If hinternetconnect <> 0 Then Call InternetCloseHandle(hinternetconnect)
    Buffer = Space(bytes)
    DoEvents
    RaiseEvent Statechanged(DWconnecting)
    hOpen = InternetOpen(Useragent, INTERNET_OPEN_TYPE_PRECONFIG, _
                         vbNullString, vbNullString, 0)
  
'-----------------Gre der Datei abfragen---------------------
            hinternetconnect = InternetConnect(hOpen, Left$(url, InStr(url, "/") - 1), _
        INTERNET_DEFAULT_HTTP_PORT, vbNullString, vbNullString, _
                INTERNET_SERVICE_HTTP, 0, 0)
        If hinternetconnect > 0 Then
            hHttpOpenRequest = HttpOpenRequest(hinternetconnect, "HEAD", _
            Right(url, Len(url) - InStr(url, "/") + _
                    1), "HTTP/1.1", vbNullString, 0, INTERNET_FLAG_RELOAD, 0)
            If CBool(hHttpOpenRequest) Then
                iretval = HttpSendRequest(hHttpOpenRequest, vbNullString, _
                0, 0, 0)
                If iretval Then
                    tmp = GetQueryInfo(hHttpOpenRequest, _
                    HTTP_QUERY_STATUS_CODE)
                    If tmp = "200" Then
                        tmp = GetQueryInfo(hHttpOpenRequest, _
                        HTTP_QUERY_RAW_HEADERS)
                        If tmp Like "*Content-Length:*" Then
                            tmp = Mid$(tmp, InStr(tmp, "Content-Length:") + Len("Content-Length:"))
                            Max = Val(Trim(tmp))
                        End If
                    End If
                End If
            End If
        End If
'----------------------------Datei herunterladen--------------------------------
hFile = InternetOpenUrl(hOpen, "Http://" & url, vbNullString, _
                            ByVal 0&, INTERNET_FLAG_RELOAD, _
                            ByVal 0&)
    If Max = 0 Then
    Err.Raise 40502, , "Keine Verbindung zum Server oder keine Grenangabe im Response-Header"
    End If
    RaiseEvent Statechanged(DWdownloading)
    RaiseEvent Startdownloading(Max)
    Call InternetReadFile(hFile, Buffer, bytes, Result&)
    Downloadfile = Downloadfile & Left$(Buffer, Result)
    Do While Result = bytes And Not OnExit
        'In einer Schleife immer ein Paket abholen
        Call InternetReadFile(hFile, Buffer, bytes, Result&)
        RaiseEvent Progresschanged(Len(Downloadfile) / Max * 100#, OnExit)
        Downloadfile = Downloadfile & Left$(Buffer, Result)
        DoEvents
    Loop
    Call InternetCloseHandle(hFile)
    hFile = 0
    Call InternetCloseHandle(hOpen)
    hOpen = 0
    Call InternetCloseHandle(hHttpOpenRequest)
    hHttpOpenRequest = 0
    Call InternetCloseHandle(hinternetconnect)
    hinternetconnect = 0
    RaiseEvent Statechanged(DWready)
    Screen.MousePointer = vbNormal
    
    If OnExit Then
        ' Bei Abbruch keinen Fehler auslsen
        Downloadfile = ""
        Max = 0
    End If
    
    If Len(Downloadfile) <> Max Then Err.Raise 40503, , "Es konnten nicht alle Daten geladen werden" 'Prfen, ob auch allen heruntergeladen wurde
End Function


Private Function GetQueryInfo(ByVal hHttpRequest As Long, ByVal iInfoLevel As Long) As String
  Dim sBuffer         As String * 1024
  Dim lBufferLength   As Long
  
  lBufferLength = Len(sBuffer)
  HttpQueryInfo hHttpRequest, iInfoLevel, ByVal sBuffer, lBufferLength, 0
  GetQueryInfo = Left$(sBuffer, lBufferLength)
End Function
